// Created by Nikolay Budin

#ifdef DEBUG
#  define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#define ff first
#define ss second
#define szof(x) ((int)x.size())
#ifndef LOCAL
#  define cerr __get_ce
#endif

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef unsigned long long ull;

using namespace __gnu_pbds;
template <typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template <typename K, typename V> using ordered_map = tree<K, V, less<K>, rb_tree_tag, tree_order_statistics_node_update>;

int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;
#ifdef LOCAL
	mt19937 tw(9450189);
#else
	mt19937 tw(chrono::high_resolution_clock::now().time_since_epoch().count());
#endif
uniform_int_distribution<ll> ll_distr;
ll rnd(ll a, ll b) { return ll_distr(tw) % (b - a + 1) + a; }


void solve() {
	string s, t;
	cin >> s >> t;

	vector<int> next_diff(szof(t), INF);
	for (int i = szof(t) - 2; i >= 0; --i) {
		if (t[i] != t[i + 1]) {
			next_diff[i] = i + 1;
		} else {
			next_diff[i] = next_diff[i + 1];
		}
	}

	vector<int> pref = {0};
	for (int i = 0; i < szof(s); ++i) {
		int pos = pref.back();
		while (pos < szof(t) && t[pos] != s[i]) {
			++pos;
		}
		++pos;
		pref.push_back(pos);
	}

	vector<int> suff = {szof(t) - 1};
	for (int i = szof(s) - 1; i >= 0; --i) {
		int pos = suff.back();
		while (0 <= pos && t[pos] != s[i]) {
			--pos;
		}
		--pos;
		suff.push_back(pos);
	}

	for (int i = 0; i < szof(s); ++i) {
		if (pref[i] <= suff[szof(s) - i - 1]) {
			if (t[pref[i]] != s[i]) {
				cout << i + 1 << " " << t[pref[i]] << "\n";
				return;
			}
			int pos = next_diff[pref[i]];
			if (pos <= suff[szof(s) - i - 1]) {
				cout << i + 1 << " " << t[pos] << "\n";
				return;
			}
		}
	}

	assert(false);
}


int main() {
#ifdef LOCAL
	auto start_time = clock();
	cerr << setprecision(3) << fixed;
#endif
	cout << setprecision(15) << fixed;
	ios::sync_with_stdio(false);
	cin.tie(nullptr);

	int test_count = 1;
	// cin >> test_count;
	for (int test = 1; test <= test_count; ++test) {
		solve();
	}

#ifdef LOCAL
	auto end_time = clock();
	cerr << "Execution time: " << (end_time - start_time) * (int)1e3 / CLOCKS_PER_SEC << " ms\n";
#endif
}