// Generator created by Nikolay Budin

#ifdef DEBUG
#  define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include "testlib.h"
#define ff first
#define ss second
#define szof(x) ((int)x.size())
#ifndef LOCAL
#  define cerr __get_ce
#endif

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef unsigned long long ull;

using namespace __gnu_pbds;
template <typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template <typename K, typename V> using ordered_map = tree<K, V, less<K>, rb_tree_tag, tree_order_statistics_node_update>;

int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;

vector<int> gen_comb(int n, int k) {
	vector<int> all(n);
	iota(all.begin(), all.end(), 0);
	shuffle(all.begin(), all.end());
	all.resize(k);
	sort(all.begin(), all.end());
	return all;
}

vector<int> gen_seq(int n, int k) {
	vector<int> ret;
	for (int i = 0; i < k; ++i) {
		ret.push_back(rnd.next(n));
	}
	return ret;
}

int main(int argc, char* argv[]) {
	registerGen(argc, argv, 1);

	int n = opt<int>("n");
	int m = opt<int>("m");
	int sinks = opt<int>("sinks");
	int paths = opt<int>("paths");

	vector<char> chars(26);
	iota(chars.begin(), chars.end(), 'a');
	shuffle(chars.begin(), chars.end());

	if (__testlib_opts.count("group3")) {
		chars = {'a'};
	}

	bool is_dag = false;
	if (__testlib_opts.count("dag")) {
		is_dag = true;
	}

	vector<int> order(n);
	iota(order.begin(), order.end(), 0);
	shuffle(order.begin(), order.end());

	vector<int> lens(paths, 0);
	for (int i = 0; i < m / 2; ++i) {
		lens[rnd.next(paths)]++;
	}

	vector<tuple<int, int, char>> edges;

	for (int i = 0; i < paths; ++i) {
		if (is_dag) {
			auto tmp = gen_comb(n - sinks, lens[i] + 1);
			vector<char> chars_seq;
			for (int j = 0; j < lens[i]; ++j) {
				chars_seq.push_back(chars[rnd.next(szof(chars))]);
			}
			for (int j = 0; j < lens[i]; ++j) {
				int a = order[tmp[j]];
				int b = order[tmp[j + 1]];
				edges.push_back({a, b, chars_seq[j]});
			}
			tmp = gen_comb(n - sinks, lens[i]);
			tmp.push_back(rnd.next(n - sinks, n - 1));
			for (int j = 0; j < lens[i]; ++j) {
				int a = order[tmp[j]];
				int b = order[tmp[j + 1]];
				edges.push_back({a, b, chars_seq[j]});
			}
		} else {
			auto tmp = gen_seq(n - sinks, lens[i] + 1);
			vector<char> chars_seq;
			for (int j = 0; j < lens[i]; ++j) {
				chars_seq.push_back(chars[rnd.next(szof(chars))]);
			}
			for (int j = 0; j < lens[i]; ++j) {
				int a = order[tmp[j]];
				int b = order[tmp[j + 1]];
				edges.push_back({a, b, chars_seq[j]});
			}
			tmp = gen_seq(n - sinks, lens[i]);
			tmp.push_back(rnd.next(n - sinks, n - 1));
			for (int j = 0; j < lens[i]; ++j) {
				int a = order[tmp[j]];
				int b = order[tmp[j + 1]];
				edges.push_back({a, b, chars_seq[j]});
			}
		}
	}

	shuffle(edges.begin(), edges.end());

	cout << n << " " << m << "\n";

	for (auto [a, b, c] : edges) {
		cout << a + 1 << " " << b + 1 << " " << c << "\n";
	}

	return 0;
}