// Created by Nikolay Budin

#ifdef DEBUG
#  define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include "testlib.h"
#define ff first
#define ss second
#define szof(x) ((int)x.size())
#ifndef LOCAL
#  define cerr __get_ce
#endif

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef unsigned long long ull;

using namespace __gnu_pbds;
template <typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template <typename K, typename V> using ordered_map = tree<K, V, less<K>, rb_tree_tag, tree_order_statistics_node_update>;

int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;

int MAXN = 1000;

int main(int argc, char* argv[]) {
	registerValidation(argc, argv);

	if (validator.group() == "1") {
		MAXN = 10;
	} else if (validator.group() == "2") {
		MAXN = 100;
	}

	int n = inf.readInt(1, MAXN, "n");
	inf.readSpace();
	int m = inf.readInt(0, MAXN, "m");
	inf.readEoln();

	vector<vector<int>> graph(n);

	for (int i = 0; i < m; ++i) {
		int a = inf.readInt(1, n, format("a_%d", i + 1)) - 1;
		inf.readSpace();
		int b = inf.readInt(1, n, format("b_%d", i + 1)) - 1;
		inf.readSpace();
		string c = inf.readToken("[a-z]", format("c_%d", i + 1));
		if (validator.group() == "3") {
			ensure(c == "a");
		}
		inf.readEoln();

		graph[a].push_back(b);
	}

	if (validator.group() == "4") {
		vector<int> used(n);

		function<bool(int)> find_cycle = [&](int v) {
			used[v] = 1;
			for (int to : graph[v]) {
				if (!used[to]) {
					if (find_cycle(to)) {
						return true;
					}
				} else if (used[to] == 1) {
					return true;
				}
			}
			used[v] = 2;
			return false;
		};

		for (int i = 0; i < n; ++i) {
			if (!used[i]) {
				ensuref(!find_cycle(i), "group #4, graph should be acyclic");
			}
		}
	}

	inf.readEof();

	return 0;
}