#include <cmath>
#include <functional>
#include <fstream>
#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <set>
#include <map>
#include <list>
#include <time.h>
#include <math.h>
#include <random>
#include <deque>
#include <queue>
#include <cassert>
#include <unordered_map>
#include <unordered_set>
#include <iomanip>
#include <bitset>
#include <sstream>
#include <chrono>
#include <cstring>

using namespace std;

typedef long long ll;

#ifdef iq
  mt19937 rnd(228);
#else
  mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());
#endif

int main() {
#ifdef iq
  freopen("a.in", "r", stdin);
#endif
  ios::sync_with_stdio(0);
  cin.tie(0);
  int n, m;
  cin >> n >> m;
  vector <int> a(m), b(m);
  vector <char> c(m);
  vector <vector <int> > g(n);
  vector <vector <int> > main_g((n + m) * n), rev_g((n + m) * n);
  for (int i = 0; i < m; i++) {
    cin >> a[i] >> b[i] >> c[i];
    a[i]--, b[i]--;
    g[a[i]].push_back(i);
  }
  auto id = [&] (int a, int b) {
    return a * n + b;
  };
  auto add_edge = [&] (int a, int b, int c, int d) {
    int u = id(a, b), v = id(c, d);
    main_g[u].push_back(v);
    rev_g[v].push_back(u);
  };
  for (int i = 0; i < n; i++) {
    for (int j = 0; j < n; j++) {
      for (int id : g[i]) {
        add_edge(i, j, n + id, j);
      }
    }
  }
  for (int i = 0; i < m; i++) {
    for (int j = 0; j < n; j++) {
      for (int id : g[j]) {
        if (c[id] == c[i]) {
          add_edge(n + i, j, b[i], b[id]);
        }
      }
    }
  }
  queue <int> q;
  vector <int> cnt((n + m) * n);
  vector <char> lose((n + m) * n);
  vector <char> win((n + m) * n);
  for (int i = 0; i < (n + m) * n; i++) {
    if (main_g[i].size() == 0) {
      q.push(i);
      lose[i] = true;
    } else {
      cnt[i] = main_g[i].size();
    }
  }
  while (!q.empty()) {
    int v = q.front();
    q.pop();
    if (win[v]) {
      for (int x : rev_g[v]) {
        cnt[x]--;
        if (cnt[x] == 0) {
          lose[x] = true;
          q.push(x);
        }
      }
    } else {
      for (int x : rev_g[v]) {
        if (!win[x]) {
          win[x] = true;
          q.push(x);
        }
      }
    }
  }
  int ans = 0;
  for (int i = 0; i < n; i++) {
    for (int j = 0; j < n; j++) {
      if (win[id(i, j)]) {
        ans++;
      }
    }
  }
  cout << ans << '\n';
}
