// Created by Nikolay Budin

#ifdef DEBUG
#  define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#define ff first
#define ss second
#define szof(x) ((int)x.size())
#ifndef LOCAL
#  define cerr __get_ce
#endif

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef unsigned long long ull;

using namespace __gnu_pbds;
template <typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template <typename K, typename V> using ordered_map = tree<K, V, less<K>, rb_tree_tag, tree_order_statistics_node_update>;

int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;
#ifdef LOCAL
	mt19937 tw(9450189);
#else
	mt19937 tw(chrono::high_resolution_clock::now().time_since_epoch().count());
#endif
uniform_int_distribution<ll> ll_distr;
ll rnd(ll a, ll b) { return ll_distr(tw) % (b - a + 1) + a; }


void solve() {
	int n, m;
	cin >> n >> m;
	vector<vector<vector<int>>> graph(n, vector<vector<int>>(26));
	vector<vector<vector<int>>> rgraph(n, vector<vector<int>>(26));
	for (int i = 0; i < m; ++i) {
		int a, b;
		char c;
		cin >> a >> b >> c;
		--a; --b;
		rgraph[b][c - 'a'].push_back(a);
		graph[a][c - 'a'].push_back(b);
	}

	vector<vector<int>> win1(n, vector<int>(n));
	vector<vector<vector<bool>>> lose2(26, vector<vector<bool>>(n, vector<bool>(n)));
	vector<vector<vector<short>>> cnt(26, vector<vector<short>>(n, vector<short>(n)));

	queue<tuple<int, int, int>> qu;
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < n; ++j) {
			for (int c = 0; c < 26; ++c) {
				if (!szof(graph[j][c])) {
					qu.push({c, i, j});
				}
			}
		}
	}

	while (szof(qu)) {
		auto [c, a, b] = qu.front();
		qu.pop();
		if (c != -1) {
			for (int from : rgraph[a][c]) {
				if (!win1[from][b]) {
					qu.push({-1, from, b});
					win1[from][b] = 1;
				}
			}
		} else {
			for (int pc = 0; pc < 26; ++pc) {
				for (int from : rgraph[b][pc]) {
					++cnt[pc][a][from];
					if (cnt[pc][a][from] == szof(graph[from][pc])) {
						lose2[pc][a][from] = 1;
						qu.push({pc, a, from});
					}
				}
			}
		}
	}

	int ans = 0;
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < n; ++j) {
			if (win1[i][j]) {
				++ans;
			}
		}
	}

	cout << ans << "\n";
}


int main() {
#ifdef LOCAL
	auto start_time = clock();
	cerr << setprecision(3) << fixed;
#endif
	cout << setprecision(15) << fixed;
	ios::sync_with_stdio(false);
	cin.tie(nullptr);

	int test_count = 1;
	// cin >> test_count;
	for (int test = 1; test <= test_count; ++test) {
		solve();
	}

#ifdef LOCAL
	auto end_time = clock();
	cerr << "Execution time: " << (end_time - start_time) * (int)1e3 / CLOCKS_PER_SEC << " ms\n";
#endif
}