/// Created by Arsenii Kirillov
 
#ifdef DEBUG
#  define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
//#include <ext/pb_ds/assoc_container.hpp>
#define fi first
#define se second
#define sz(x) ((int)x.size())
#define all(x) x.begin(),x.end()
#ifndef LOCAL
#  define cerr __get_ce
#endif
 
using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef unsigned long long ull;
 
/*
using namespace __gnu_pbds;
template <typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template <typename K, typename V> using ordered_map = tree<K, V, less<K>, rb_tree_tag, tree_order_statistics_node_update>;
//*/
 
int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;
#ifdef LOCAL
	mt19937 tw(9450189);
#else
	mt19937 tw(chrono::high_resolution_clock::now().time_since_epoch().count());
#endif
uniform_int_distribution<ll> ll_distr;
ll rnd(ll a, ll b) { return ll_distr(tw) % (b - a + 1) + a; }
 
struct line {
	ll k, b;
	line (ll k_ = 1e8, ll b_ = 1e8): k(k_), b(b_) {};
	ll get(ll x) {
		return k * x + b;
	}
};

struct lichao {
	int sz;
	vector<line> mas;
	lichao(int sz_ = 0) {
		sz = sz_;
		mas.resize(4 * sz);
	}
	void add(line li) {
		int v = 0, l = 0, r = sz;
		while (r - l > 0) {
			int m = (l + r) / 2;
			if (mas[v].get(m) > li.get(m))
				swap(mas[v], li);
			if (li.k > mas[v].k) {
				r = m;
				v = 2 * v + 1;
			} else {
				l = m + 1;
				v = 2 * v + 2;
			}
		}
	}
	ll get(int x) {
		ll ans = INFL;
		int v = 0, l = 0, r = sz;
		while (r - l > 0) {
			int m = (l + r) / 2;
			ans = min(ans, mas[v].get(x));
			if (x == m)
				return ans;
			if (x < m) {
				r = m;
				v = 2 * v + 1;
			} else {
				l = m + 1;
				v = 2 * v + 2;
			}
		}
		return ans;
	}
};
 
void solve() {
	int n;
	cin >> n;
	vector<int> q(n), t(n);
	vector<vector<lichao>> mas(3, vector<lichao>(6));
	for (int i = 0; i < 3; i++) {
		for (int j = 0; j < 2 * i + 2; j++) {
			mas[i][j] = lichao(n / (2 * i + 2) + 3);
		}
	}
	vector<ll> dp(n + 1, INFL);
	dp[0] = 0;
	for (int i = 0; i < n; i++) {	
		cin >> q[i] >> t[i];
	}
	ll ans = INFL;
	for (int i = 0; i < n; i++) {
		ll add = 0;
		for (int j = i + 2 * t[i]; j < n + 300; j += 2 * t[i]) {
			add += q[i];
			if (j < n)
				dp[j] = min(dp[j], dp[i] + add);
			else if (j > n) {
				ans = min(ans, dp[i] + add);
				break;
			}
		}
	}
	cout << ans << endl;
}
 
 
int main() {
#ifdef LOCAL
	auto start_time = clock();
	cerr << setprecision(3) << fixed;
#endif
	cout << setprecision(15) << fixed;
	ios::sync_with_stdio(false);
	cin.tie(nullptr);
 
	int test_count = 1;
	//cin >> test_count;
	for (int test = 1; test <= test_count; ++test) {
		solve();
	}
 
#ifdef LOCAL
	auto end_time = clock();
	cerr << "Execution time: " << (end_time - start_time) * (int)1e3 / CLOCKS_PER_SEC << " ms\n";
#endif
}